/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	Roles 管理XMO サーバクラス
//			変更履歴
//				2004.01.08	新規作成	二條智文

package jp.co.ntt.lms.xmo.Roles;

import java.rmi.Naming;
import java.rmi.RemoteException;
import java.rmi.RMISecurityManager;
import java.rmi.server.UnicastRemoteObject;
import java.util.*;
import java.sql.*;
import jp.co.ntt.lms.xmo.*;
import jp.co.ntt.lms.xmo.Message.Message;
import jp.co.ntt.lms.xmo.util.DebugLog;
import jp.co.ntt.lms.xmo.Environment;
/**
 * Roles 管理XMO サーバクラスです。<BR>
 * XMO基本メソッドを実装し、クライアントからの登録、更新、削除、検索処理
 * 要求をうけそれぞれの処理を行います。<BR>
 * RMIサーバとして動作するためRemoteインタフェースであるXMOインタフェースを実装し、
 * 永続的な起動状態を確保するためjava.rmi.server.UnicastRemoteObjectクラスを継承します。
 * @author T.Nijou
 * @version 0.0.0.1 2004.01.08
 */
public class Roles extends UnicastRemoteObject
	implements XMO, RolesMessage, RolesTable
{

	//////////////////////////////////////////////////////////////////
	// メソッド名定義
	//////////////////////////////////////////////////////////////////
	/** 登録メソッド名です */
	private static final String METHOD1 = "insert";	// 登録
	/** 更新メソッド名です */
	private static final String METHOD2 = "update";	// 更新
	/** 削除メソッド名です */
	private static final String METHOD3 = "delete";	// 削除
	/** 検索メソッド名です */
	private static final String METHOD4 = "select";	// 検索
	/** Xmo関連テーブル登録メソッド名です */
	private static final String METHOD5 = "insertXmoRelation";	// 登録
	/** Xmo関連テーブル更新メソッド名です */
	private static final String METHOD6 = "updateXmoRelation";	// 更新
	/** Xmo関連テーブル削除メソッド名です */
	private static final String METHOD7 = "deleteXmoRelation";	// 削除
	/** Xmo関連テーブル検索メソッド名です */
	private static final String METHOD8 = "selectXmoRelation";	// 検索
	/** FunctionからRoleIdを検索するメソッド名です */
	private static final String METHOD9 = "selectFunction";	// 検索

//	ADD 2005/02/02 START MASUDA [LO一覧(履修済み/中)対応]
	/** RoleIdからFunctionを検索するメソッド名です */
	private static final String METHOD10 = "selectRolesFunction";	// 検索
//	ADD 2005/02/02 END MASUDA 

	/** XMOメッセージ番号 */
	public static final String XMO_MSG_NUM = "10";

	/**
	 * Rolesテーブルアクセスクラスを保持します
	 */
	private RolesDataAccess pobjDataAccess = new RolesDataAccess();

	/**
	 * コンストラクタです。<BR>
	 */
	public Roles() throws RemoteException {
		// リモートオブジェクトをエクスポートする
		// java.rmi.server.UnicastRemoteObject の
		// 引数なしのコンストラクタを呼び出す
		super();
	}

	/**
	 * メニュー一覧を返します
	 * @return Vector メニュー一覧
	 */
	public Vector getMenuList(Hashtable htbParam) {
		Vector vecMenuList = new Vector();
		try {
			RolesEnv objEnv = RolesEnv.getInstance();
			vecMenuList = objEnv.getMenuList();
		}
		catch( Exception e ) {
			return new Vector();
		}
		return vecMenuList;
	}

	/**
	 * メソッド一覧を返します
	 * @return Vector
	 */
	public Vector getMethodList() {
		Vector vecMenuList = new Vector();
		try {
			RolesEnv objEnv = RolesEnv.getInstance();
			vecMenuList = objEnv.getMenuList();
		}
		catch( Exception e ) {
			return new Vector();
		}
		return vecMenuList;
	}

	/**
	 * デフォルトメニューを返します
	 * @return MenuData
	 */
	public MenuData getDefaultMenu() {
		return null;
	}

	/**
	 * このXMOで定義された、メソッドのクライアント側からの入り口になるメソッドです。
	 * @param strMethodName 実行するメソッド名を指定します
	 * @param htData メソッドで実行するパラメータを指定します<BR>
	 *               なお必要なキーと値は各DAOの処理メソッドの説明を参照して下さい。
	 * @retunr Object 戻り値（さまざまな戻り値に対応するためObject型としてあります)<BR>
	 *                受け取り側では適切な値にキャストする必要があります。
	 */
	public Object execute( String strMethodName, Hashtable htData ) {

		Object objReturn = null;

		if( strMethodName.equals( METHOD1 ) ) {
			objReturn = insert( htData );
		}
		else if( strMethodName.equals( METHOD2 ) ) {
			objReturn = update( htData );
		}
		else if( strMethodName.equals( METHOD3 ) ) {
			objReturn = delete( htData );
		}
		else if( strMethodName.equals( METHOD4 ) ) {
			objReturn = select( htData );
		}
		else if( strMethodName.equals( METHOD5 ) ) {
			objReturn = insertXmoRelation( htData );
		}
		else if( strMethodName.equals( METHOD6 ) ) {
			objReturn = updateXmoRelation( htData );
		}
		else if( strMethodName.equals( METHOD7 ) ) {
			objReturn = deleteXmoRelation( htData );
		}
		else if( strMethodName.equals( METHOD8 ) ) {
			objReturn = selectXmoRelation( htData );
		}
		else if( strMethodName.equals( METHOD9 ) ) {
			objReturn = selectFunction( htData );
		}
//	ADD 2005/02/02 START MASUDA [LO一覧(履修済み/中)対応]
		else if( strMethodName.equals( METHOD10 ) ) {
			objReturn = selectRolesFunction( htData );
		}
//	ADD 2005/02/02 END MASUDA 

		return objReturn;
	}

	/**
	 * 起動確認（必ずtrueを返す）
	 * @return boolean 必ずtrueが返ります
	 */
	public boolean isLaunch() {
		return true;
	}

	/**
	 * Rolesテーブル.RolesFunctionテーブルへ登録処理を行います。<BR>
	 * 以下のパラメータチェックを行い、すべてOKの場合は
	 * DAOの登録処理メソッドを実行します。
	 * <PRE>
	 *             key                     説明
	 *          ---------------------------------------------
	 *             ROLENAME                権限名称
	 *             DELETED                 隠しフラグ
	 *             FUNCTION                機能(XMOID)
	 *          ---------------------------------------------
	 * </PRE>
	 * @param htData 登録情報
	 * @return Vector 結果（配列の先頭にMessageDataオブジェクトを格納して返します)
	 */
	private Vector insert( Hashtable htData ) {
		Vector vecReturn = new Vector();

		MessageData objMessage = null;
		// 登録処理のパラメータチェックを行います
		String strMessage = insertCheck( htData );
		if( strMessage.equals( "" ) ) {
			try {
				strMessage = pobjDataAccess.insert( htData );
			}
			catch( XMOException xe ) {
				strMessage = xe.getMessage();
			}
		}
		else {
			DebugLog.write( this.getClass(), new Exception(), DebugLog.HIGHT );	
			objMessage = getMessageData( strMessage );
		}
		vecReturn.add( objMessage );
		return vecReturn;
	}

	/**
	 * Rolesテーブル,RolesFunctionへ更新処理を行います。<BR>
	 * 以下のパラメータチェックを行い、すべてOKの場合は
	 * DAOの更新処理メソッドを実行します。
	 * <PRE>
	 *             key                     説明
	 *          ---------------------------------------------
	 *             CONDITION_KEY           更新条件文
	 *          ---------------------------------------------
	 * </PRE>
	 * @param htData 登録情報
	 * @return Vector 結果（配列の先頭にMessageDataオブジェクトを格納して返します)
	 */
	private Vector update( Hashtable htData ) {
		Vector vecReturn = new Vector();
		MessageData objMessage = null;
		// 更新処理のパラメータチェックを行います
		String strMessage = updateCheck( htData );
		if( strMessage.equals( "" ) ) {
			try {
				pobjDataAccess.update( htData );
			}
			catch( XMOException xe ) {
				objMessage = xe.getMessageData();
			}
		}
		else {
			DebugLog.write( this.getClass(), new Exception(), DebugLog.HIGHT );	
			objMessage = getMessageData( strMessage );
		}
		vecReturn.add( objMessage );
		return vecReturn;
	}

	/**
	 * Rolesテーブルへ削除処理を行います。<BR>
	 * 以下のパラメータチェックを行い、すべてOKの場合は
	 * DAOの削除処理メソッドを実行します。
	 * <PRE>
	 *             key                     説明
	 *          ---------------------------------------------
	 *             CONDITION_KEY           更新条件文
	 *          ---------------------------------------------
	 * </PRE>
	 * @param htData 削除情報
	 * @return Vector 結果（配列の先頭にMessageDataオブジェクトを格納して返します)
	 */
	private Vector delete( Hashtable htData ) {
		Vector vecReturn = new Vector();
		MessageData objMessage = null;
		try {
			pobjDataAccess.delete( htData );
		}
		catch( XMOException xe ) {
			objMessage = xe.getMessageData();
		}
		vecReturn.add( objMessage );
		return vecReturn;
	}

	/**
	 * Rolesテーブルへ検索処理を行います。<BR>
	 * 以下のパラメータチェックを行い、すべてOKの場合は
	 * DAOの検索処理メソッドを実行します。
	 * <PRE>
	 *             key                     説明
	 *          ---------------------------------------------
	 *             CONDITION_KEY           更新条件文
	 *          ---------------------------------------------
	 * </PRE>
	 * @param htData 検索情報
	 * @return Vector 結果（配列の先頭にMessageDataオブジェクトを格納し、２番目移行に
	 *                      RolesDataクラスを格納して返します。)
	 */
	private Vector select( Hashtable htData ) {
		Vector vecResult = new Vector();
		MessageData objMessage = null;
		try {
			vecResult = pobjDataAccess.select( htData );
		}
		catch( XMOException xe ) {
			objMessage = xe.getMessageData();
		}

		// 配列の先頭にメッセージデータを格納する
		vecResult.add( 0, objMessage );
		return vecResult;
	}

	/**
	 * XmoRelationテーブルへ登録処理を行います。<BR>
	 * 以下のパラメータチェックを行い、すべてOKの場合は
	 * DAOの登録処理メソッドを実行します。
	 * <PRE>
	 *             key                     説明
	 *          ---------------------------------------------
	 *             XMOID                   XMOID
	 *             RELATEDID               関連XMOID
	 *          ---------------------------------------------
	 * </PRE>
	 * @param htData 登録情報
	 * @return Vector 結果（配列の先頭にMessageDataオブジェクトを格納して返します)
	 */
	private Vector insertXmoRelation( Hashtable htData ) {
		Vector vecReturn = new Vector();

		MessageData objMessage = null;
		// 登録処理のパラメータチェックを行います
		String strMessage = insertXmoRelationCheck( htData );
		if( strMessage.equals( "" ) ) {
			try {
				strMessage = pobjDataAccess.insertXmoRelation( htData );
			}
			catch( XMOException xe ) {
				strMessage = xe.getMessage();
			}
		}
		else {
			objMessage = getMessageData( strMessage );
		}
		vecReturn.add( objMessage );
		return vecReturn;
	}

	/**
	 * XmoRelationテーブルへ更新処理を行います。<BR>
	 * 以下のパラメータチェックを行い、すべてOKの場合は
	 * DAOの更新処理メソッドを実行します。
	 * <PRE>
	 *             key                     説明
	 *          ---------------------------------------------
	 *             CONDITION_KEY           更新条件文
	 *          ---------------------------------------------
	 * </PRE>
	 * @param htData 更新情報
	 * @return Vector 結果（配列の先頭にMessageDataオブジェクトを格納して返します)
	 */
	private Vector updateXmoRelation( Hashtable htData ) {
		Vector vecReturn = new Vector();
		MessageData objMessage = null;
		// 更新処理のパラメータチェックを行います
		String strMessage = updateXmoRelationCheck( htData );
		if( strMessage.equals( "" ) ) {
			try {
				pobjDataAccess.updateXmoRelation( htData );
			}
			catch( XMOException xe ) {
				objMessage = xe.getMessageData();
			}
		}
		else {
			objMessage = getMessageData( strMessage );
		}
		vecReturn.add( objMessage );
		return vecReturn;
	}

	/**
	 * XmoRelationテーブルへ削除処理を行います。<BR>
	 * 以下のパラメータチェックを行い、すべてOKの場合は
	 * DAOの削除処理メソッドを実行します。
	 * <PRE>
	 *             key                     説明
	 *          ---------------------------------------------
	 *             CONDITION_KEY           削除条件文
	 *          ---------------------------------------------
	 * </PRE>
	 * @param htData 削除情報
	 * @return Vector 結果（配列の先頭にMessageDataオブジェクトを格納して返します)
	 */
	private Vector deleteXmoRelation( Hashtable htData ) {
		Vector vecReturn = new Vector();
		MessageData objMessage = null;
		try {
			pobjDataAccess.deleteXmoRelation( htData );
		}
		catch( XMOException xe ) {
			objMessage = xe.getMessageData();
		}
		vecReturn.add( objMessage );
		return vecReturn;
	}

	/**
	 * XmoRelationテーブルへ検索処理を行います。<BR>
	 * 以下のパラメータチェックを行い、すべてOKの場合は
	 * DAOの検索処理メソッドを実行します。
	 * <PRE>
	 *             key                     説明
	 *          ---------------------------------------------
	 *             CONDITION_KEY           検索条件文
	 *          ---------------------------------------------
	 * </PRE>
	 * @param htData 検索情報
	 * @return Vector 結果（配列の先頭にMessageDataオブジェクトを格納し、２番目移行に
	 *                      RolesDataクラスを格納して返します。)
	 */
	private Vector selectXmoRelation( Hashtable htData ) {
		Vector vecResult = new Vector();
		MessageData objMessage = null;
		try {
			vecResult = pobjDataAccess.selectXmoRelation( htData );
		}
		catch( XMOException xe ) {
			objMessage = xe.getMessageData();
		}

		// 配列の先頭にメッセージデータを格納する
		vecResult.add( 0, objMessage );
		return vecResult;
	}


	/**
	 * メッセージオブジェクトを作成します
	 * @param strMessageID メッセージID
	 * @return MessageData メッセージオブジェクト 例外発生時はnullを返します
	 */
	private MessageData getMessageData( String strMessageID) {
		MessageData objMessage = null;
		try {
			objMessage = Message.getInstance().getMessageData( strMessageID, MSG_FIEL_PATH, MSG_FILE_NAME );
		}
		catch( Exception e ) {

		}
		return objMessage;
	}

	/**
	 * 追加処理のパラメータチェックを行います<BR>
	 * 以下のパラメータのチェックを行います。
	 * <PRE>
	 *             key                     説明
	 *          ---------------------------------------------
	 *             ROLE_ID                 権限ID
	 *             ROLE_NAME               権限名称
	 *             DELETED                 隠しフラグ
	 *             FUNCTION                機能(XMOID)
	 *          ---------------------------------------------
	 * </PRE>
	 * @param htbParam パラメータ
	 * @return String エラー時はエラー番号 OKのときは空文字を返します
	 */
	private String insertCheck( Hashtable htbParam ) {

		String strMessage = "";
		String strCheck = "";

		// 権限IDのチェック
		strCheck = (String)htbParam.get( ROLEID );
		strMessage = RolesCheck.checkRoleID( strCheck, false );
		if( !strMessage.equals( "" ) ) {
			return strMessage;
		}

		// 権限名称のチェック(必須チェックあり)
		strCheck = (String)htbParam.get( ROLENAME );
		strMessage = RolesCheck.checkRoleName( strCheck, true );
		if( !strMessage.equals( "" ) ) {
			return strMessage;
		}

		// 隠しフラグのチェック(必須チェックあり)
		strCheck = (String)htbParam.get( DELETED );
		strMessage = RolesCheck.checkDeleted( strCheck, true );
		if( !strMessage.equals( "" ) ) {
			return strMessage;
		}

		// 機能(XMOID)のチェック
		Vector vecFunction = new Vector();
		try{
			// 環境ファイルからDB種別情報取得
			Environment objEnv = new Environment();
			//DB種別情報が "0" の時　MS SQLServer
			//DB種別情報が "1" の時　Oracle
			//DB種別情報が "2" の時　PostgreSQL
			//SQLServerの場合
			if ( objEnv.getDBType().equals(objEnv.DB_SQLSERVER) ) {
				vecFunction = (Vector)htbParam.get(FUNCTION);
			//Oracleの場合
			}else if(objEnv.getDBType().equals( objEnv.DB_ORACLE )){
				vecFunction = (Vector)htbParam.get(ORACLE_FUNCTION);
			//PostgreSQLの場合
			}else if(objEnv.getDBType().equals( objEnv.DB_POSTGRE )){
				vecFunction = (Vector)htbParam.get(POSTGRE_FUNCTION);
			}
		}
		catch( Exception e )
		{
			DebugLog.write( this.getClass(), e, DebugLog.HIGHT );
		}
		if( vecFunction != null ) {
			for( int i = 0; i < vecFunction.size(); i++ ) {
				strCheck = (String)vecFunction.get(i);
				strMessage = RolesCheck.checkFunction( strCheck, false );
				if( !strMessage.equals( "" ) ) {
					return strMessage;
				}
			}
		}

		// 正常時は空文字を返す
		return "";
	}

	/**
	 * 更新処理のパラメータチェックを行います<BR>
	 * 以下のパラメータのチェックを行います。
	 * <PRE>
	 *             key                     説明
	 *          ---------------------------------------------
	 *             ROLE_ID                 権限ID
	 *             ROLE_NAME               権限名称
	 *             DELETED                 隠しフラグ
	 *             FUNCTION                機能(XMOID)
	 *          ---------------------------------------------
	 * </PRE>
	 * @param htbParam パラメータ
	 * @return String エラー時はエラー番号 OKのときは空文字を返します
	 */
	private String updateCheck( Hashtable htbParam ) {

		String strMessage = "";
		String strCheck = "";

		// 権限IDのチェック
		strCheck = (String)htbParam.get( ROLEID );
		strMessage = RolesCheck.checkRoleID( strCheck, false );
		if( !strMessage.equals( "" ) ) {
			return strMessage;
		}

		// 権限名称のチェック(必須チェックあり)
		strCheck = (String)htbParam.get( ROLENAME );
		strMessage = RolesCheck.checkRoleName( strCheck, true );
		if( !strMessage.equals( "" ) ) {
			return strMessage;
		}

		// 隠しフラグのチェック(必須チェックあり)
		strCheck = (String)htbParam.get( DELETED );
		strMessage = RolesCheck.checkDeleted( strCheck, true );
		if( !strMessage.equals( "" ) ) {
			return strMessage;
		}

		// 機能(XMOID)のチェック
		Vector vecFunction = new Vector();
		try{
			// 環境ファイルからDB種別情報取得
			Environment objEnv = new Environment();
			//DB種別情報が "0" の時　MS SQLServer
			//DB種別情報が "1" の時　Oracle
			//DB種別情報が "2" の時　PostgreSQL
			//SQLServerの場合
			if ( objEnv.getDBType().equals(objEnv.DB_SQLSERVER) ) {
				vecFunction = (Vector)htbParam.get(FUNCTION);
			//Oracleの場合
			}else if(objEnv.getDBType().equals( objEnv.DB_ORACLE )){
				vecFunction = (Vector)htbParam.get(ORACLE_FUNCTION);
			//PostgreSQLの場合
			}else if(objEnv.getDBType().equals( objEnv.DB_POSTGRE )){
				vecFunction = (Vector)htbParam.get(POSTGRE_FUNCTION);
			}
		}
		catch( Exception e )
		{
			DebugLog.write( this.getClass(), e, DebugLog.HIGHT );
		}
		if( vecFunction != null ) {
			for( int i = 0; i < vecFunction.size(); i++ ) {
				strCheck = (String)vecFunction.get(i);
				strMessage = RolesCheck.checkFunction( strCheck, false );
				if( !strMessage.equals( "" ) ) {
					return strMessage;
				}
			}
		}

		// 正常時は空文字を返す
		return "";
	}

	/**
	 * XmoRelation追加処理のパラメータチェックを行います<BR>
	 * 以下のパラメータのチェックを行います。
	 * <PRE>
	 *             key                     説明
	 *          ---------------------------------------------
	 *             XMOID                   XMOID
	 *             RELATEDID               関連XMOID
	 *          ---------------------------------------------
	 * </PRE>
	 * @param htbParam パラメータ
	 * @return String エラー時はエラー番号 OKのときは空文字を返します
	 */
	private String insertXmoRelationCheck( Hashtable htbParam ) {

		String strMessage = "";
		String strCheck = "";

		// XmoIDのチェック
		strCheck = (String)htbParam.get( XMOID );
		strMessage = RolesCheck.checkXmoID( strCheck, false );
		if( !strMessage.equals( "" ) ) {
			return strMessage;
		}

		// Xmo名称のチェック(必須チェックあり)
		Vector vecCheck = (Vector)htbParam.get( RELATEDID );
		for(int i = 0; i < vecCheck.size(); i++)
		{
			strCheck = (String)vecCheck.get(i);
			strMessage = RolesCheck.checkRelatedID( strCheck, true );
			if( !strMessage.equals( "" ) ) {
				return strMessage;
			}
		}
		// 正常時は空文字を返す
		return "";
	}

	/**
	 * 更新処理のパラメータチェックを行います<BR>
	 * 以下のパラメータのチェックを行います。
	 * <PRE>
	 *             key                     説明
	 *          ---------------------------------------------
	 *             XMOID                   XMOID
	 *             RELATEDID               関連XMOID
	 *          ---------------------------------------------
	 * </PRE>
	 * @param htbParam パラメータ
	 * @return String エラー時はエラー番号 OKのときは空文字を返します
	 */
	private String updateXmoRelationCheck( Hashtable htbParam ) {

		String strMessage = "";
		String strCheck = "";

		// 権限IDのチェック
		strCheck = (String)htbParam.get( XMOID );
		strMessage = RolesCheck.checkXmoID( strCheck, false );
		if( !strMessage.equals( "" ) ) {
			return strMessage;
		}

		// 権限名称のチェック(必須チェックあり)
		Vector vecCheck = (Vector)htbParam.get( RELATEDID );
		for(int i = 0; i < vecCheck.size(); i++)
		{
			strCheck = (String)vecCheck.get(i);
			strMessage = RolesCheck.checkRelatedID( strCheck, true );
			if( !strMessage.equals( "" ) ) {
				return strMessage;
			}
		}

		// 正常時は空文字を返す
		return "";
	}
	
	/**
	 * FunctionをもとにロールIDリストを取得します
	 * @param htData パラメータ
	 * @return Vector 結果
	 */
	private Vector selectFunction( Hashtable htData ) {
		Vector vecResult = new Vector();
		MessageData objMessage = null;
		try {
			vecResult = pobjDataAccess.selectFunction( htData );
		}
		catch( XMOException xe ) {
			objMessage = xe.getMessageData();
		}

		// 配列の先頭にメッセージデータを格納する
		vecResult.add( 0, objMessage );
		return vecResult;
	}

//	ADD 2005/02/02 START MASUDA [LO一覧(履修済み/中)対応]
	/**
	 * FunctionをもとにロールIDリストを取得します
	 * @param htData パラメータ
	 * @return Vector 結果
	 */
	private Vector selectRolesFunction( Hashtable htData ) {
		Vector vecResult = new Vector();
		MessageData objMessage = null;
		String strRoleID = (String)htData.get( ROLEID );			
		try {

		vecResult = pobjDataAccess.selectRolesFunction( strRoleID );
		}
		catch( XMOException xe ) {
			objMessage = xe.getMessageData();
		}

		return vecResult;
	}
//	ADD 2005/02/02 END MASUDA 

}

